Global ConstraintIterations:Int = 20	'constraint iterations

Global constcount:Int	'Number of constraints ever made
Global Constraintarray:Constraint[200]	'constraint array
Global Constraintcollisionarray:constraint[100]

Global constcolcount:Int 'number of constraints ready for colliding

Type Constraint
	
	Field index:Int
	Field caindex:Int 'collisionarray index
	Field solid:Int
	Field v1:Verlet
	Field v2:Verlet
	Field Length:Float
	Field Elasticity:Float
	Field hidden:Int = False
	Field breakpoint:Float
	Field setremove:Int
	
	
	Function Create:Constraint(v1:Verlet, v2:Verlet, elasticity:Float = 1, breakpoint:Int = 0,solid:Int = False, Length:Float = -1)
		
		Local CC:Constraint = New Constraint
		CC.v1:Verlet = v1:Verlet
		CC.v2:Verlet = v2:verlet
		cc.breakpoint = breakpoint
		
		If length < 0 Then
			CC.Length = Sqr( (v1.x - v2.x)^2 + (v1.y - v2.y)^2 )	'Distance formula for the length
		Else
			CC.Length = Length
		EndIf
		CC.Elasticity = elasticity
		
		constraintarray:constraint[constcount] = CC:constraint
		CC.index = constcount
		Constcount = constcount + 1
		
		If solid Then
			cc.solid = True
			constraintcollisionarray:constraint[constcolcount] = cc:constraint
			cc.index = constcolcount
			constcolcount :+1
			If Constraintcollisionarray.length-Constcolcount => 2 Then constraintcollisionarray = constraintcollisionarray[..(constraintcollisionarray.length + 300)]
		EndIf
		If Constraintarray.length-Constcount <= 2 Then constraintarray = constraintarray[..(constraintarray.length + 300)]
		
		Return CC:Constraint
	End Function
	
	Method hide()
	
		hidden = True
	
	End Method
	
	Method show()
		
		hidden = False
	
	End Method
	
	Method remove()
		
		constcount = constcount - 1
		constraintarray:constraint[index] = constraintarray:constraint[constcount]
		Local ctmp:constraint = constraintarray:constraint[index]
		ctmp.index = index
		
	End Method
	
End Type





Function UpdateConstraints()	'constraint update function
	
	Local c:constraint
	Local totalmass#
	Local v1prop#
	Local v2prop#
	Local dx#
	Local dy#
	Local length#
	Local diff#
	Local mutip#
	
	For Local a:Int = 1 To ConstraintIterations
		For Local ccnt:Int = 0 To constcount - 1
			c:constraint = constraintarray:constraint[ccnt]
			
			If c.v1.deleted Or c.v2.deleted Then
				c.remove
			Else
				totalmass# = c.v1.mass# + c.v2.mass#
				
				v1prop# = (c.v1.mass#/totalmass#) * 2
				v2prop# = (c.v2.mass#/totalmass#) * 2
				
				dx# = c.v1.x - c.v2.x
				dy# = c.v1.y - c.v2.y
				
				length# = Sqr(dx#*dx# + dy#*dy#)
				
				
				If length# <> 0 Then
					diff# = (length# - c.length)
				Else
					diff# = 0
				EndIf
				
				If c.breakpoint > 0 Then
					If diff => c.breakpoint Then
						c.setremove = True
					EndIf
				EndIf
				
				diff# = diff# / length#
				
				dx# = dx# * .5
				dy# = dy# * .5
				
				If c.elasticity = 1 Then
					If a > ConstraintIterations - 8 Then	' take out this if statement and everything between the else and enif if you want to increase speed but lose stability
						If c.v1.active = True And c.v2.active = True Then
							c.v1.x = c.v1.x - (diff# * dx#) * v2prop#
							c.v1.y = c.v1.y - (diff# * dy#) * v2prop#
							c.v2.x = c.v2.x + (diff# * dx#) * v1prop#
							c.v2.y = c.v2.y + (diff# * dy#) * v1prop#
						EndIf
						
						If c.v2.active = True And c.v1.active = False Then
							c.v2.x = c.v2.x + (diff# * dx#)
							c.v2.y = c.v2.y + (diff# * dy#)
						EndIf
						
						If c.v1.active = True And c.v2.active = False Then
							c.v1.x = c.v1.x - (diff# * dx#)
							c.v1.y = c.v1.y - (diff# * dy#)
						EndIf
						
					Else
						If c.v1.active = True And c.v2.active = True Then
							c.v1.x = c.v1.x - ((diff# * dx#) * v2prop#)/20
							c.v1.y = c.v1.y - ((diff# * dy#) * v2prop#)/20
							c.v2.x = c.v2.x + ((diff# * dx#) * v1prop#)/20
							c.v2.y = c.v2.y + ((diff# * dy#) * v1prop#)/20
						EndIf
						
						If c.v2.active = True And c.v1.active = False Then
							c.v2.x = c.v2.x + (diff# * dx#)/20
							c.v2.y = c.v2.y + (diff# * dy#)/20
						EndIf
						
						If c.v1.active = True And c.v2.active = False Then
							c.v1.x = c.v1.x - (diff# * dx#)/20
							c.v1.y = c.v1.y - (diff# * dy#)/20
						EndIf
	
					EndIf
				Else
					mutip# = c.elasticity'*constraintiterations
					If c.v1.active = True Then
						c.v1.x = c.v1.x - ((diff# * dx#) * v2prop#)/mutip
						c.v1.y = c.v1.y - ((diff# * dy#) * v2prop#)/mutip
					EndIf
					If c.v2.active = True Then
						c.v2.x = c.v2.x + ((diff# * dx#) * v1prop#)/mutip
						c.v2.y = c.v2.y + ((diff# * dy#) * v1prop#)/mutip
					EndIf
				EndIf
				c.v1.collided = False
				c.v2.collided = False
				
				If a = constraintiterations Then
					If c.setremove Then
						c.remove
					EndIf
				EndIf
			EndIf
		Next
	Next

End Function


Rem

Function DoCCollisions()
	
	Local ccn:Int = 0	'just some counting vars
	Local cn:Int = 0
	Local c:constraint	'constraint instance that will be used
	Local v:verlet	'verlet instance that will be used
	Local tmppoly:Float[]
	
	For cn = 0 To constcolcount - 1
		c:constraint = constraintcollisionarray:constraint[cn]
		For ccn = 0 To verlcount - 1
			v:verlet = verletarray:verlet[ccn]
			If v.ID <> c.v1.ID And v.ID <> c.v2.ID Then
				Local dx# = v.x-v.ox
				Local dy# = v.y-v.oy
				Local dist# = Sqr(dx*dx + dy*dy)
				If dist# = 0 Then dist = 1 And dx = 0 And dy = 0
				
					If lines_intersect(v.ox,v.oy,v.x+dx/dist*2,v.y+dy/dist*2,c.v1.x,c.v1.y,c.v2.x,c.v2.y) Then	'did the point pass over the constraint?
						Local vex# = v.x-Intersection_x
						Local vey# = v.y-Intersection_y
						Local mw1# = c.v2.mass/c.v1.mass
						Local mw2# = c.v1.mass/c.v2.mass
						Local d1#
						Local d2#
						If c.v1.x=c.v2.x Then
							d1 = Abs(c.v1.y-Intersection_y)
							d2 = Abs(c.v2.y-Intersection_y)
						Else
							d1 = Abs(c.v1.x-Intersection_x)
							d2 = Abs(c.v2.x-Intersection_x)
						EndIf
						Local tm# = c.v1.mass + c.v2.mass + v.mass
						Local w1# = 1
						If d1 <> 0 Then w1# = d2/d1
						Local w2# = 1
						If d2 <> 0 Then w2# = d1/d2
						Local fx# = Intersection_x + vex*(v.mass/tm) + (c.v1.x-c.v1.ox)*(c.v1.mass/tm) + (c.v2.x-c.v2.ox)*(c.v2.mass/tm)
						Local fy# = Intersection_y + vey*(v.mass/tm) + (c.v1.y-c.v1.oy)*(c.v1.mass/tm) + (c.v2.y-c.v2.oy)*(c.v2.mass/tm)
						Local dfx# = fx-Intersection_x
						Local dfy# = fy-Intersection_y
						DrawOval fx-4,fy-4,8,8
						
						ccollide.Create(c:constraint,v:verlet,c.v1.x + (w1*mw1)*dfx,c.v1.y + (w1*mw1)*dfy,c.v2.x + (w2*mw2)*dfx,c.v2.y + (w2*mw2)*dfy,fx,fy)
					Else
						
						Local tmp:Float[][]' = linecircleintersect([c.v1.x,c.v1.y],[c.v2.x,c.v2.y],[v.x,v.y],5)
						If tmp Then
							Local i1x# = tmp[1][0]
							Local i1y# = tmp[1][1]
							Local i2x# = tmp[0][0]
							Local i2y# = tmp[0][1]
							
							Local imx# = (i1x + i2x) / 2
							Local imy# = (i1y + i2y) / 2
							
							If (imx# => c.v1.x And imx# <= c.v2.x) Or (imx# <= c.v1.x And imx# => c.v2.x) Then
								Local acqrcoords:Float[] = acqrdistance(imx# , imy# , v.x , v.y , 5)
								v.x = acqrcoords[0]
								v.y = acqrcoords[1]
							EndIf

						Else
							tmppoly = [c.v1.x,c.v1.y,c.v1.ox,c.v1.oy,c.v2.ox,c.v2.oy,c.v2.x,c.v2.y]
							If pointinpoly(v.ox,v.oy,tmppoly)	
								Local xy:Float[] = [c.v1.x,c.v1.y,c.v1.ox,c.v1.oy,c.v2.ox,c.v2.oy,c.v2.x,c.v2.y]									'did the constraint pass over the point?
								DrawPoly xy
								
							EndIf
						EndIf
						
					EndIf
				
			EndIf
			
		Next
	Next
	ccollide.update	'moves all constraints to their collided position
	
End Function
EndRem

Function DoCCollisions()
	
	Local ccn:Int = 0	'just some counting vars
	Local cn:Int = 0
	Local c:constraint	'constraint instance that will be used
	Local v:verlet	'verlet instance that will be used
	Local tmppoly:Float[]	'stores polygons
	
	For cn = 0 To constcolcount - 1
		c:constraint = constraintcollisionarray:constraint[cn]
		
		For ccn = 0 To verlcount - 1
			v:verlet = verletarray:verlet[ccn]
			If v.ID <> c.v1.ID And v.ID <> c.v2.ID Then
				Local dx# = v.x-v.ox
				Local dy# = v.y-v.oy
				Local dist# = Sqr(dx*dx + dy*dy)
				If dist# = 0 Then dist = 1 And dx = 0 And dy = 0
				
					If lines_intersect(v.ox,v.oy,v.x+dx/dist*2,v.y+dy/dist*2,c.v1.x,c.v1.y,c.v2.x,c.v2.y) Then	'did the point pass over the constraint?
						Local vex# = v.x-Intersection_x
						Local vey# = v.y-Intersection_y
						Local mw1# = c.v2.mass/c.v1.mass
						Local mw2# = c.v1.mass/c.v2.mass
						Local d1#
						Local d2#
						If c.v1.x=c.v2.x Then
							d1 = Abs(c.v1.y-Intersection_y)
							d2 = Abs(c.v2.y-Intersection_y)
						Else
							d1 = Abs(c.v1.x-Intersection_x)
							d2 = Abs(c.v2.x-Intersection_x)
						EndIf
						Local tm# = c.v1.mass + c.v2.mass + v.mass
						Local w1# = 1
						If d1 <> 0 Then w1# = d2/d1
						Local w2# = 1
						If d2 <> 0 Then w2# = d1/d2
						Local fx# = Intersection_x + vex*(v.mass/tm) + (c.v1.x-c.v1.ox)*(c.v1.mass/tm) + (c.v2.x-c.v2.ox)*(c.v2.mass/tm)
						Local fy# = Intersection_y + vey*(v.mass/tm) + (c.v1.y-c.v1.oy)*(c.v1.mass/tm) + (c.v2.y-c.v2.oy)*(c.v2.mass/tm)
						Local dfx# = fx-Intersection_x
						Local dfy# = fy-Intersection_y
						DrawOval fx-4,fy-4,8,8
						
						ccollide.Create(c:constraint,v:verlet,c.v1.x + (w1*mw1)*dfx,c.v1.y + (w1*mw1)*dfy,c.v2.x + (w2*mw2)*dfx,c.v2.y + (w2*mw2)*dfy,fx,fy)
					Else
						
						Local tmp:Float[][]' = linecircleintersect([c.v1.x,c.v1.y],[c.v2.x,c.v2.y],[v.x,v.y],5)
						If tmp Then
							Local i1x# = tmp[1][0]
							Local i1y# = tmp[1][1]
							Local i2x# = tmp[0][0]
							Local i2y# = tmp[0][1]
							
							Local imx# = (i1x + i2x) / 2
							Local imy# = (i1y + i2y) / 2
							
							If (imx# => c.v1.x And imx# <= c.v2.x) Or (imx# <= c.v1.x And imx# => c.v2.x) Then
								Local acqrcoords:Float[] = acqrdistance(imx# , imy# , v.x , v.y , 5)
								v.x = acqrcoords[0]
								v.y = acqrcoords[1]
							EndIf

						Else
							tmppoly = [c.v1.x,c.v1.y,c.v1.ox,c.v1.oy,c.v2.ox,c.v2.oy,c.v2.x,c.v2.y]
							If pointinpoly(v.ox,v.oy,tmppoly)	
								Local xy:Float[] = [c.v1.x,c.v1.y,c.v1.ox,c.v1.oy,c.v2.ox,c.v2.oy,c.v2.x,c.v2.y]									'did the constraint pass over the point?
								DrawPoly xy
								
							EndIf
						EndIf
						
					EndIf
				
			EndIf
			
		Next
	Next
	ccollide.update	'moves all constraints to their collided position
	
End Function


