Private
Global GridArray:Grid[100]
Global Gridlength:Int
Global GridWidth:Int
Global GridColumnCount:Int = 0
Global GridRowCount:Int = 0
Public
Global GridActive:Int = False

Type Grid	'this preforms fixed grid optimizations
	Field x:Int	'x and y in array not in the physics world
	Field y:Int
	
	Field VIG:verlet[20]
	Field VIGcount:Int
	
	Function Active:Int()
		Return GridActive
	End Function
	
	Function GridSize:Int()
		Return GridLength
	End Function
	
	Function Activate:Int(siz:Int)
		maxverlsiz = siz
		gridlength = maxverlsiz
		gridwidth = gridlength
		GridColumncount = (physicsrightbound-physicsleftbound)/gridwidth + 1
		GridRowCount = (physicslowerbound-physicsupperbound)/gridlength + 1
		gridarray = gridarray[..((GridRowCount+1)*(GridColumnCount+1))]
		GridActive = True
		
		Local x:Int = 0
		Local y:Int = 0
		
		For x = 0 To (GridColumnCount*GridRowCount)-1
			Gridarray:grid[x] = New grid
		Next
		
		Local g:grid
		For x = 0 To GridColumncount-1
			For y = 0 To gridRowCount-1
				g:grid = Gridarray:grid[(x+y*GridColumnCount)]
				g.x = x
				g.y = y
			Next
		Next
		Return True 
	End Function
	
	Function Clear()	'clears the grid
		Local g:grid
		Local i:Int
		For i = 0 To (GridRowCount*GridColumnCount)-1
			g:grid = GridArray:grid[i]
			g.VIGcount = 0
		Next
	End Function
	
	Function Update()
		Grid.Clear		'clear the grid
		Grid.Sort		'sort each verlet into the grid
		Grid.Collisions	'calculate collisions for each grid piece
	End Function
	
	
	Function Collisions()
		Local g:grid
		Local gg:grid
		Local ggg:grid
		Local x:Int = 0
		Local y:Int = 0
		Local xflag:Int = 0
		Local yflag:Int = 0
		
		For y = 0 To gridrowcount-1				'loop through the y values of our grid
			For x = 0 To GridColumncount-1		'loop through the x values of our grid
				
				g:grid = gridarray:grid[(x + (y)*GridColumnCount)]	'get the grid position we are at
				If g.VIGcount Then	'if grid has any verlets in it then... oh heres the problem... not the main one though
					xflag = 0	'if grid is not on the x border
					yflag = 0	'if grid is not on the y border
					grid.collidegrid(g:grid,g:grid)	'do self collisions
					
					If g.y < gridrowcount-1 Then yflag = True	'set the x and y flags
					If g.x < gridcolumncount-1 Then xflag = True
					
					If xflag Then	'if x isnt on the border then
						
						ggg:grid = gridarray:grid[g.x+1+(g.y)*GridColumnCount]
						grid.collidegrid(g:grid,ggg:grid)
						
						If yflag Then	'if x and y arent on the border then
							gg:grid = gridarray:grid[g.x+(g.y+1)*GridColumnCount]
							grid.collidegrid(g:grid,gg:grid)
							
							grid.collidegrid(gg:grid,ggg:grid)
							
							gg:grid = gridarray:grid[g.x+1+(g.y+1)*gridColumnCount]
							grid.collidegrid(g:grid,gg:grid)
							
						EndIf
					Else
						If yflag Then	'if y isnt on the border but x is then
							gg:grid = gridarray:grid[g.x+(g.y+1)*GridColumnCount]
							grid.collidegrid(g:grid,gg:grid)
						EndIf
					EndIf
					
				Else
					xflag = False
					yflag = False
					If g.y < gridrowcount-1 Then yflag = True
					If g.x < gridcolumncount-1 Then xflag = True
					
					If xflag Then
						If yflag Then
							gg:grid = gridarray:grid[g.x+(g.y+1)*GridColumnCount]
							ggg:grid = gridarray:grid[g.x+1+(g.y)*GridColumnCount]
							
							grid.collidegrid(gg:grid,ggg:grid)
						EndIf
					EndIf	
									
				EndIf
				
			Next
		Next
	End Function
	
	Function CollideGrid(g:grid,gg:grid)
		If g.VIGCount And gg.VIGcount Then
			Local v:verlet
			Local vv:verlet
			For Local cnt1:Int = 0 To g.VIGcount-1
				For Local cnt2:Int = 0 To gg.VIGcount-1
					v:verlet = g.VIG:verlet[cnt1]
					If g = gg Then v.done = True
					vv:verlet = gg.VIG:verlet[cnt2]
					If (v <> vv) And ((g = gg And vv.done = False) Or g >< gg) Then DoVcollisions(v:verlet,vv:verlet)
				Next
			Next
		EndIf
	End Function
	
	Function Sort()
		Local vcnt:Int
		Local v:verlet
		Local x:Int
		Local y:Int
		Local xx:Int
		Local yy:Int
		Local g:grid
		For vcnt = 0 To verlcount-1	'loop through all verlets and place them in the correct grid cells
			v:verlet = verletarray:verlet[vcnt]	'extracts verlet out of verlet array
			
			x = (v.x-physicsleftbound)/GridWidth		'computes the x and y grid position the verlets should be stored in
			y = (v.y-physicsupperbound)/Gridwidth
			If x > -1 And y > -1 And x < gridcolumncount And y < gridrowcount Then
				g:grid = gridarray:grid[x+y*GridColumnCount]	'gets the grid instance out of the grid array
				g.add(v:verlet)		'adds verlet to the grid cell
			EndIf
			
			If v.siz*2 > gridlength Then
				Local scl:Float = (v.siz/(gridlength))*8
				For xx = -scl To scl
					For yy = -scl To scl
						If xx <> 0 Or yy >< 0 Then
							xx = xx + x
							yy = yy + y
							If xx > -1 And xx < gridcolumncount And yy > -1 And yy < gridrowcount Then
								g:grid = gridarray:grid[xx+yy*GridColumnCount]	'gets the grid instance out of the grid array
								g.add(v:verlet)
							EndIf
						EndIf
					Next
				Next
			EndIf
			
		Next
	End Function
	
	Function IsActive:Int()	'allows user to know if the grid is active or not
		Return GridActive
	End Function
	
	Method add(v:verlet)
		VIG:verlet[VIGcount] =  v:verlet
		VIGcount :+ 1
		If VIGcount > VIG.length - 2 Then VIG = VIG[..VIG.length+20]
		v.GD:grid = Self
	End Method
	
End Type
