'this is internal and not to be tampered with
'Description: constraints between fluid particles to eliminate some of the compression that happens with the original system

Type flconstraint
	Global flcarray:flconstraint[10]
	Global flcarraycnt:Int = 0
	
	Field index:Int
	Field length:Float
	Field elasticity:Float 'different from the normal constraint elasticity
	Field elasticityi:Float	'elasticity inside of radius
	Field v1:verlet
	Field v2:verlet
	Field v1v2flag:Int
	Field mass:Float
	
	Function Create:flconstraint(v1:verlet,v2:verlet,length:Float,elasticity:Float,elasticityi:Float,flag:Int)
		Local c:flconstraint = New flconstraint
		c.v1 = v1
		c.v2 = v2
		c.length = length
		c.elasticity = elasticity
		c.elasticityi = elasticityi
		c.index = flcarraycnt
		c.v1v2flag = flag
		c.mass = c.v1.mass+c.v2.mass
		flcarray:flconstraint[flcarraycnt] = c:flconstraint
		flcarraycnt :+1
		If flcarraycnt > flcarray.length-2 Then
			flcarray = flcarray[..(flcarray.length+200)]
		EndIf
		Return c:flconstraint
	End Function
	
	Function update()
		Local c:flconstraint
		Local v:verlet
		Local vv:verlet
		Local len1:Float
		Local len2:Float
		Local vvms:Float
		Local vms:Float
		Local tms:Float
		Local dx:Float
		Local dy:Float
		Local dist:Float
		Local ddiff:Float
		Local celasticity:Float
		Local celasticityi:Float
		Local ddflag:Int
		
		Local i:Int
		Local itcnt:Int	'iterations
		For itcnt = 0 To 2
			For i = 0 To flcarraycnt-1
				c:flconstraint = flcarray:flconstraint[i]
				v:verlet = c.v1:verlet
				vv:verlet = c.v2:verlet
				dx:Float = c.v1.x-c.v2.x
				dy:Float = c.v1.y-c.v2.y
				dist:Float = dx*dx + dy*dy
				dist = Sqr(dist)
				celasticity = c.elasticity
				celasticityi = c.elasticityi
				
				If dist < c.length Then
					ddflag = True
				Else
					ddflag = False
				EndIf
				tms = c.mass
				If dist > 0 Then
					If c.v1v2flag = 1 Then
						'len2 = vv.flrad + v.flrad
						
						'If dist# <= (len2) Then
							len1 = c.length
							dx = dx / dist
							dy = dy / dist
							
							ddiff = len1-dist
							dx:* ddiff
							dy:* ddiff
							
							vvms = v.mass/tms
							vms = vv.mass/tms
							If ddflag Then
								dx = dx * celasticityi
								dy = dy * celasticityi
							Else
								dx = dx * celasticity
								dy = dy * celasticity
							EndIf
							If v.active Then
								v.x:+ dx*vms
								v.y:+ dy*vms
							EndIf
							If vv.active Then
								vv.x:- dx*vvms
								vv.y:- dy*vvms
							EndIf
						'EndIf
						
					ElseIf c.v1v2flag = 2 Then
						'only the v is a fluid
						'len2 = v.flrad + vv.siz
						'If dist# <= (len2) Then
							
							len1 = c.length
							dx = dx / dist
							dy = dy / dist
							
							ddiff = len1-dist
							dx:* ddiff
							dy:* ddiff
							
							vvms = v.mass/tms
							vms = vv.mass/tms
							
							If ddflag Then
								dx = dx * celasticityi
								dy = dy * celasticityi
							Else
								dx = dx * celasticity
								dy = dy * celasticity
							EndIf
							
							If v.active Then
								v.x:+ dx*vms
								v.y:+ dy*vms
							EndIf
							If vv.active Then
								vv.x:- dx*vvms
								vv.y:- dy*vvms
							EndIf
							
						'EndIf
					ElseIf c.v1v2flag = 3 Then
						
						'only the vv is a fluid
						'len2 = vv.flrad + v.siz
						
						'If dist# <= (len2) Then
							len1 = c.length
							dx = dx / dist
							dy = dy / dist
							ddiff = len1-dist
							dx:* ddiff
							dy:* ddiff
							vvms = v.mass/tms
							vms = vv.mass/tms
							If ddflag Then
								dx = dx * celasticityi
								dy = dy * celasticityi
							Else
								dx = dx * celasticity
								dy = dy * celasticity
							EndIf
							If v.active Then
								v.x:+ dx*vms
								v.y:+ dy*vms
							EndIf
							If vv.active Then
								vv.x:- dx*vvms
								vv.y:- dy*vvms
							EndIf
							
						'EndIf
						
					EndIf
				EndIf
			Next
		Next
		
		For i = 0 To flcarraycnt-1
			c:flconstraint = flcarray:flconstraint[i]
			c.remove()
		Next
	End Function
	
	Method remove()
		flcarraycnt :-1
		flcarray:flconstraint[index] = flcarray:flconstraint[flcarraycnt]
		Local fl:flconstraint = flcarray:flconstraint[index]
		fl.index = index
	End Method
	
End Type

Global flplist:TList = New TList	'fluid property list

Type FLProperty
	Field frad:Float
	Field flen:Float
	Field fflex:Float
	Field fflexi:Float
	Field flid1:Int
	Field flid2:Int
	
	Function Create:FLProperty(flid1:Int,flid2:Int,frad:Float,flen:Float,fflex:Float,fflexi:Float)
		Local f:flproperty = New flproperty
		f.flid1 = flid1
		f.flid2 = flid2
		f.frad = frad*2
		f.flen = flen*2
		f.fflexi = fflexi
		f.fflex = fflex
		flplist.addlast(f:flproperty)
		Return f:flproperty
	End Function
	
	Method set(id1:Int,id2:Int,rad:Float,Lenf:Float,flex:Float,flexi:Float)
		flid1 = id1
		flid2 = id2
		frad = rad*2
		flen = lenf*2
		fflex = flex
		fflexi = flexi
	End Method
	
	Method getradius:Float()
		Return frad/2
	End Method
	
	Method getlength:Float()
		Return flen/2
	End Method
	
	Method remove()
		flplist.remove(Self)
	End Method
End Type


Global FLRlist:TList = New TList		'fluid reaction list

Type FLReaction		'fluid reaction
	Field v1id:Int	'fluid id's
	Field v2id:Int
	
	Field v1delt:Int	'is it gunna be deleted?
	Field v2delt:Int
	
	Field v1cpy:verlet	'instance of verlet it will turn into if any
	Field v2cpy:verlet
	
	Function Create:FLReaction(v1id:Int,v2id:Int,v1delt:Int,v2delt:Int,v1cpy:verlet = Null,v2cpy:verlet = Null)
		Local f:flreaction = New flreaction
		f.v1id = v1id
		f.v2id = v2id
		f.v1delt = v1delt
		f.v2delt = v2delt
		f.v1cpy:verlet = v1cpy:verlet
		f.v2cpy:verlet = v2cpy:Verlet
		flrlist.addlast(f:flreaction)
		Return f:flreaction
	End Function
	
	Function react(v1:verlet,v2:verlet,flr:flreaction)	'cause two verlets to react with a certain reaction
		If flr.v1delt = True Then
			v1.remove
			If flr.v2delt = True Then
				v2.remove
			Else
				If Not(flr.v2cpy:verlet = Null) Then
					v2.replaceproperties(flr.v2cpy:verlet)
				EndIf
			EndIf
		Else
			If flr.v2delt = True Then
				v2.remove
			Else
				If Not(flr.v2cpy:verlet = Null) Then
					v2.replaceproperties(flr.v2cpy:verlet)
				EndIf
			EndIf
			If Not(flr.v1cpy:verlet = Null) Then
				v1.replaceproperties(flr.v1cpy:verlet)
			EndIf
		EndIf
	End Function
	
End Type