'used for line intersect functions

Global Intersection_X#
Global Intersection_Y#
Global Intersection_AB#
Global Intersection_CD#

Function acqrdistance#[](x:Float,y:Float,x2:Float,y2:Float,acqdist:Float)	'x = col point x2 = center of collided circle ditto for y's  acqdist = the distance to acquire between these two points
	
	Local temparay#[]
	Local nx:Float
	Local ny:Float
	Local dx! = x - x2	'doubles because these are the cause of most floating point inacuracy that causes jerking and bouncing around
	Local dy!= y - y2
	Local dist:Float = Sqr(dx*dx + dy*dy)
	
	If dist < acqdist And dist > 0 Then
		
		dx = (dx / dist) * acqdist
		dy = (dy / dist) * acqdist
		nx = x - dx
		ny = y - dy
		
	Else
		nx = x2
		ny = y2
	EndIf
	
	temparay# = [nx,ny]
	
	Return temparay#
	
End Function



Function acqrdistance2#[](x:Float,y:Float,x2:Float,y2:Float,acqdist:Float)	'x = col point x2 = center of collided circle ditto for y's  acqdist = the distance to acquire between these two points
	
	Local temparay#[]
	Local nx:Float
	Local ny:Float
	Local dx! = x - x2	'doubles because these are the cause of most floating point inacuracy that causes jerking and bouncing around
	Local dy!= y - y2
	Local dist:Float = Sqr(dx*dx + dy*dy)
	
	If dist > 0 Then	'took out dist < acqdist
		
		dx = (dx / dist) * acqdist
		dy = (dy / dist) * acqdist
		nx = x + dx
		ny = y + dy
		
	Else
		nx = x2
		ny = y2
	EndIf
	
	temparay# = [nx,ny]
	
	Return temparay#
	
End Function




Function linecircleintersect#[][]( pLineStart#[], pLineEnd#[], pCircleCenter#[], pCircleRadius# )	'many thanks to blitz support for this one!
	
	Local tmpIntersections#[][]
	
	Local p# = pCircleCenter[0], q# = pCircleCenter[1]
	Local m# = (pLineEnd[1]-pLineStart[1])/(pLineEnd[0]-pLineStart[0])
	Local r# = pCircleRadius
	Local t# = pLineEnd[1]- (m*pLineEnd[0])
	Local s# = t-q
	
	Local a# = m*m + 1, b# = (2*m*s) - (2*p), c# = s*s + p*p - (r*r)
	
	Local bsqminfourac# = b*b-4*a*c
	
	If bsqminfourac > 0 Then
		
		bsqminfourac = Sqr(bsqminfourac)
		
		Local x1# = ((-b)+bsqminfourac)/(2*a)
		Local x2# = ((-b)-bsqminfourac)/(2*a)
		
		tmpIntersections = [[x1,(m*x1)+t],[x2,(m*x2)+t]]
		
	ElseIf bsqminfourac = 0 Then
		
		tmpIntersections = [[(-b)/(2*a),(-b*m)/(2*a)+t]]
		
	EndIf
	
	Return tmpIntersections

EndFunction


Function Lines_Intersect:Int(Ax#, Ay#, Bx#, By#, Cx#, Cy#, Dx#, Dy#)	'finds the line intersections... never mind commenting the math.. I dont even understand it anymore
	Local dymcy# = dy - cy
	Local dxmcx# = dx - cx
	
	Local Rn# = (Ay#-Cy#)*(DxmCx#) - (Ax#-Cx#)*(DymCy#)
	Local Rd# = (Bx#-Ax#)*(DymCy#) - (By#-Ay#)*(DxmCx#)
		
	If Rd# = 0 
		
		' Lines are parralel.
		' If Rn# is also 0 Then lines are coincident.  All points intersect. 
		' Otherwise, there is no intersection point.
		Return False
	Else
		' The lines intersect at some point.  Calculate the intersection point.
	Local Sn# = (Ay#-Cy#)*(Bx#-Ax#) - (Ax#-Cx#)*(By#-Ay#)
		Intersection_AB# = Rn# / Rd#
		Intersection_CD# = Sn# / Rd#
		Intersection_X# = Ax# + Intersection_AB#*(Bx#-Ax#)
		Intersection_Y# = Ay# + Intersection_AB#*(By#-Ay#)	
	EndIf
		
	If Intersection_AB#>0 And Intersection_AB#<1 And Intersection_CD#>0 And Intersection_cd#<1
			Return True	
		Else
			Return False
	EndIf


End Function


Function UpdateVerletPolysegCollisions()

Local cnt:Int = 0
Local v:verlet

For cnt = 0 To Verlcount-1
	V:verlet = Verletarray:Verlet[cnt]
	If V.active = True Then
		
		
		v.checkverletbounds
					
			If v.ghost = False Then updatepolysegs(v:verlet)
				
	EndIf
	
Next

End Function





'|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
'thanks for the following two functions "another JIM"
'Finds out if a point is on the left or right side of a segment
Function LineIntersectOX:Int(lx1:Float, ly1:Float, lx2:Float, ly2:Float, px:Float, py:Float)
	Local newpx:Float
	
	If ((ly1 < py) And (ly2 > py) ..
		Or (ly1 > py) And (ly2 < py)) And (lx1 > px) And (lx2 > px)
		Return True
	End If
	
	Local b:Int = ((ly1 <= py) And (ly2 >= py)) Or ((ly1 >= py) And (ly2 <= py))
	If (b = False)
		Return False
	EndIf
	
	If ly2 = ly1 Then
		Return False
	Else	
		newpx = ((py - ly1) / (ly2 - ly1)) * (lx2 - lx1) + lx1
		If (px < newpx) Return True
	EndIf
	Return False
End Function

'finds out if a point is inside a polygon
Function PointInPoly:Int(px:Float, py:Float, poly:Float[])
	Local i:Int
	Local sum:Int

	For i = 0 To Int(poly.length / 2) - 2
		Local p1x:Float = poly[i * 2]
		Local p1y:Float = poly[i * 2 + 1]
		Local p2x:Float = poly[(i + 1) * 2]
		Local p2y:Float = poly[(i + 1) * 2 + 1]
		
		sum:+LineIntersectOX(p1x, p1y, p2x, p2y, px, py)
	Next
	
	If (poly.length > 4)
		Local p1xd:Float = poly[0]
		Local p1yd:Float = poly[1]
		Local p2xd:Float = poly[poly.length - 2]
		Local p2yd:Float = poly[poly.length - 1]
		
		sum:+LineIntersectOX(p1xd, p1yd, p2xd, p2yd, px, py)
	End If
	
	Return sum Mod 2
End Function
'|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

